var validaty = new function() {

	// public functions
	// ----------------

	this.init = function() {
		this.pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.validaty.");

		// developer or not?
		validaty.dev = false;
		try {
			validaty.dev = this.pref.getBoolPref("developer");
		} catch(e) {
		}
		traceLog("Validaty - 1.3.0");

		try {
			// listen for when the user switches tabs
			gBrowser.mTabContainer.addEventListener("select", function(e) {validaty.resetValidator(1)}, true);
		} catch(e) {
			traceLog("tab switch error due to: " + e);
		}

		try {
			// listen for when the cached pages are shown
			document.getElementById("appcontent").addEventListener("pageshow", function(e) {validaty.resetValidator(1)}, true);
		} catch(e) {
			traceLog("cache page error due to: " + e);
		}
	},

	this.initevery = function(aEvent) {
		// see http://kb.mozillazine.org/On_page_load
		if (aEvent.originalTarget.nodeName == "#document") {
			traceLog("every load");
			this.resetValidator(1);
		}
	},

	this.initeveryun = function(aEvent) {
		if (aEvent.originalTarget.nodeName == "#document") {
			traceLog("every unload");
			this.resetValidator(2);
			try {
				// try to avoid leaks
				gBrowser.mTabContainer.removeEventListener("select", function(e) {validaty.resetValidator(1);}, true);
				document.getElementById("appcontent").removeEventListener("pageshow", function(e) {validaty.resetValidator(1)}, true);
			} catch(e) {
				traceLog("remove event error due to: " + e);
			}
		}
	},

	this.resetValidator = function(aState) {
		// reset the validator icon
		var but = document.getElementById("validaty-toolbar");
		if (!but) {
			traceLog("no need to update -  reset");
		} else {
			traceLog("resetting icon");
			but.removeAttribute("tooltiptext");
			if (aState) {
				if (aState == 2) {
					traceLog("disabled due to unload");
					but.setAttribute("disabled", true);
				} else {
					traceLog("set tooltip due to load");
					var bun = document.getElementById("bundle_validaty");
					but.setAttribute("tooltiptext", bun.getString("validate-ready.tooltiptext"));
					but.removeAttribute("disabled");
				}
			} else {
				traceLog("remove disabled");
				but.removeAttribute("disabled");
			}
			// remove any childnodes
			if (but.hasChildNodes()) {
				but.removeChild(but.childNodes[0]);
			}
			but.removeAttribute("type");
			but.removeAttribute("status");
		}
	},

	this.lp = function(aUrl) {
		loadPage(aUrl);
	},

	this.validatePage = function() {
		this.resetValidator();
		var uu = getURL();
		// make sure we have a page that we can validate
		var uri = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
		uri.spec = uu;
		var but = document.getElementById("validaty-toolbar");
		var bun = document.getElementById("bundle_validaty");
		if (uri.scheme && uri.host && uri.scheme != "about") {
			but.setAttribute("disabled", true);
			but.setAttribute("status", "working");
			but.setAttribute("tooltiptext", bun.getString("validate-working.tooltiptext"));
			traceLog("about to validate: " + uu);
			var valurl;
			try {
				valurl = validaty.pref.getCharPref("validatorurl");
			} catch(e) {
				traceLog("unable to get validator url due to: " + e, 1);
			}
			var valurlreport = valurl + "check?ss=1&verbose=1&uri=" + escape(uu);
			valurl += "check?output=xml&uri=" + escape(uu);
			var nsuri = "uri";
			var nserror = "errors";
			if (getDocument().contentType == "text/css") {
				traceLog("CSS document detected");
				valurl = "http://jigsaw.w3.org/css-validator/validator?output=soap12&uri=" + escape(uu);
				valurlreport = "http://jigsaw.w3.org/css-validator/validator?uri=" + escape(uu);
				nsuri = "m:uri";
				nserror = "m:errorcount";
			}
			var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
			req.onreadystatechange = function() {
				if (req.readyState == 4) {
					but.removeAttribute("working");
					but.removeAttribute("disabled");
					var ok = false;
					var stat;
					try {
						stat = req.status;
					} catch(e) {
						traceLog("unable to get status due to: " + e, 1);
					}
					if (stat) {
						if (stat == 200) {
							var doc = req.responseXML;
							if (doc) {
								try {
									// xml needs to have uri to be valid
									var uri = doc.getElementsByTagName(nsuri);
									if (uri && uri.length && uri.item(0).firstChild && uri.item(0).firstChild.nodeValue) {
										var errors = parseInt(doc.getElementsByTagName(nserror).item(0).firstChild.nodeValue);
										traceLog("responseText is: " + req.responseText);
										traceLog("Errors: " + errors);
										if (errors > 0) {
											but.setAttribute("status", "notvalid");
											but.setAttribute("tooltiptext", replaceInsert(bun.getString("validate-errors.tooltiptext"), 1, errors));
											but.setAttribute("type", "menu-button");
											var ele = document.createElement("menupopup");
											but = but.appendChild(ele);
											ele = document.createElement("menuitem");
											ele.setAttribute("label", replaceInsert(bun.getString("validate-report.label"), 1, errors));
											ele.setAttribute("oncommand", "validaty.lp('" + valurlreport + "'); event.stopPropagation();");
											ele.setAttribute("tooltiptext", bun.getString("validate-report-open.label"));
											but.appendChild(ele);
										} else {
											but.setAttribute("status", "valid");
											but.setAttribute("tooltiptext", bun.getString("validate-errors-no.tooltiptext"));
										}
										ok = true;
									} else {
										traceLog("no uri in: " + req.responseText, 1);
									}
								} catch(e) {
									traceLog("no uri in: " + req.responseText, 1);
								}
							} else {
								traceLog("no responseXML", 1);
							}
						} else {
							traceLog("error loading " + valurl + " status was " + stat, 1);
					}
					} else {
						traceLog("unable to get status", 1);
					}
					if (!ok) {
						but.setAttribute("tooltiptext", bun.getString("validate-no.label"));
						but.setAttribute("status", "error");
					}
				}
			}
			traceLog("Getting URL: " + valurl);
			req.open("GET", valurl);
			req.send(null);
		} else {
			but.setAttribute("tooltiptext", bun.getString("validate-no.label"));
			but.setAttribute("status", "error");
			traceLog("unable to validate " + uu, 1);
		}
	};

	// private functions
	// -----------------

	function getDocument() {
		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var recentWindow = wm.getMostRecentWindow("navigator:browser");
		var ret = false;
		try {
			if (recentWindow) {
				ret = recentWindow.content.document;
			}
		} catch(e) {
			traceLog("unable to get document due to: " + e);
		}
		return ret;
	};

	function getURL() {
		var doc = getDocument();
		var loc = "";
		try {
			if ("location" in doc) {
				if ("href" in doc.location) {
					loc = doc.location.href;
				} else {
					traceLog("no href in doc.location");
				}
			} else {
				traceLog("no location in doc");
			}
		} catch(e) {
			traceLog("unable to get url due to: " + e);
		}
		return loc;
	};

	function replaceInsert(aTxt, aNumber, aTxtReplace) {
		var result = aTxt;
		if (result) {
			var re = new RegExp("#" + aNumber, "g");
			result = result.replace(re, aTxtReplace);
		}
		return result;
	};

	function traceLog(aText, aForce) {
		if (aForce || validaty.dev) {
			try {
				var CONSOLE_SERVICE = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
				CONSOLE_SERVICE.logStringMessage("validaty: " + aText);
			} catch(e) {
			}
		}
	};

	function loadPage(aUrl, aCurrentTab) {
		var windowService = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var currentWindow = windowService.getMostRecentWindow("navigator:browser");
		if (currentWindow) {
			try {
				if (aCurrentTab) {
					currentWindow.loadURI(aUrl);
				} else {
					currentWindow.delayedOpenTab(aUrl);
				}
			} catch(e) {
				currentWindow.loadURI(aUrl);
			}
		} else {
			window.open(aUrl);
		}
	};

}

// start it the first time we start the app
window.addEventListener("load", function(e) {validaty.init(e)}, false);
// start it every time a page has loaded and unloaded
if (document.getElementById("appcontent")) {
	document.getElementById("appcontent").addEventListener("load", function(e) {validaty.initevery(e)}, true);
	document.getElementById("appcontent").addEventListener("unload", function(e) {validaty.initeveryun(e)}, true);
}
